:------------------------------------------------------------------
: dos_dist.bat
:
: DOS batch file for creating a PC/X11e distribution.
: where $(TARGETDIR) is wherever the user chooses for installation.
: Preserving this structure is important for the frontend mechanism.
:
: Running this BAT file
: ---------------------
: distribution. Assumes:
:
:   - a standard binaries have been created under src170\*.exe
:     These are created with "dos_all.bat"
:   - file utils are under msdos\bin.
:
: Send questions to Arlindo da Silva (dasilva@alum.mit.edu)
: ams, 20 April 98
:------------------------------------------------------------------
  
: Directories referenced by this BAT file
: ---------------------------------------
  set  TARGET=c:\pcgrads
  set     BIN=%TARGET%\msdos
  set     UDF=%TARGET%\udf
  set   FUTIL=..\msdos\bin
  set    FUDF=..\msdos\udf

: Create directories if they are not there
: ----------------------------------------
  if not exist %TARGET%    mkdir %TARGET%
  if not exist %BIN%       mkdir %BIN%

: Start cleaning up
: -----------------
  del %BIN%\0*
  del %BIN%\*.pl 
  del %BIN%\*.bak
  del %BIN%\*.bat
  del %BIN%\*.hlp
  del %UDF%\*.*

  @echo Msdos distribution directory has been cleaned up.
  @echo Press ^C to cancel setup of msdos-dist.
  @pause

: Now copy GrADS binaries & UDF
: -----------------------------
  copy *.exe                                     %BIN%
  copy %FUDF%\*.*                                %UDF%

: Now the file utils
: ------------------
  copy %FUTIL%\0readme                            %TARGET%
  copy %FUTIL%\0install                           %TARGET%
  copy %FUTIL%\License.txt                        %TARGET%
  copy %FUTIL%\*.exe                              %BIN%
  copy %FUTIL%\*.hlp                              %BIN%
  copy %FUTIL%\*.doc                              %BIN%
  copy %FUTIL%\*.bat                              %BIN%
  copy %FUTIL%\*.pl                               %BIN%
  move %BIN%\mkzip.bat                            %TARGET%

: All done
: --------  
  @echo All done.
